/*
Copyright (C) 2019 Apogee Software, Ltd.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

//#include "zone.h"


#ifndef __linklist_h
#define __linklist_h


#define NewNode(type)  ((type*)malloc(sizeof(type)))


#define LL_CreateNewLinkedList(rootnode,type,next,prev) \
   {                                                    \
   rootnode = NewNode(type);                            \
   rootnode->prev = (rootnode);                         \
   rootnode->next = (rootnode);                         \
   }



#define LL_AddNode(rootnode, newnode, next, prev) \
   {                                              \
   newnode->next = rootnode;                      \
   newnode->prev = rootnode->prev;                \
   rootnode->prev->next = newnode;                \
   rootnode->prev = newnode;                      \
   }

#define LL_TransferList(oldroot,newroot,next,prev)  \
   {                                                \
   if (oldroot->prev != oldroot)                    \
      {                                             \
      oldroot->prev->next = newroot;                \
      oldroot->next->prev = newroot->prev;          \
      newroot->prev->next = oldroot->next;          \
      newroot->prev = oldroot->prev;                \
      oldroot->next = oldroot;                      \
      oldroot->prev = oldroot;                      \
      }                                             \
   }


#define LL_RemoveNode(node,next,prev) \
   {                                  \
   node->prev->next = node->next;     \
   node->next->prev = node->prev;     \
   node->next = node;                 \
   node->prev = node;                 \
   }


#define LL_SortedInsertion(rootnode,insertnode,next,prev,type,sortparm) \
   {                                                                    \
   type *hoya;                                                          \
                                                                        \
   hoya = rootnode->next;                                               \
   while((hoya != rootnode) && (insertnode->sortparm > hoya->sortparm)) \
      {                                                                 \
      hoya = hoya->next;                                                \
      }                                                                 \
   LL_AddNode(hoya,insertnode,next,prev);                               \
   }

#define LL_MoveNode(node,newroot,next,prev) \
   {                                        \
   LL_RemoveNode(node,next,prev);           \
   LL_AddNode(newroot,node,next,prev);      \
   }


#endif



